<?php
/*
Plugin Name: Syntax Highlighter for WordPress-MU
Version: 1.5.1
Plugin URI: http://www.ringofblogs.com
Author: Elad Salomons
Author URI: http://www.ringofblogs.com
Description: This plugin is based on the <a href="http://code.google.com/p/syntaxhighlighter">Syntax highlighter</a> to highlight code snippets within WordPress-MU. Supports C++, C#, CSS, Delphi, Java, JavaScript, PHP, Python, Ruby, SQL, VB, XML, and HTML.

		"Cpp" 		=> "C++"
		"CSharp" 	=> "C#"
		"Css" 		=> "CSS"
		"Delphi" 	=> "Delphi, Pascal"
		"Java" 		=> "Java"
		"JScript" 	=> "JavaScript"
		"Php" 		=> "PHP"
		"Python" 	=> "Python"
		"Ruby" 		=> "Ruby"
		"Sql" 		=> "SQL"
		"Vb" 		=> "VisualBasic, VB.NET"
		"Xml" 		=> "XML, XHTML, XSLT, HTML"
*/

global $IsCodeInPost;

// Parse the posting thx to that damn autoformatting
function syntaxPost( $thePost ) {

	global $IsCodeInPost;

	if( strpos( $thePost, '[source:' ) !== false ) {
		
		$IsCodeInPost = 1;
		
		// Grab all source-tags
		preg_match_all ( '!\[source:(.*)\](.*)\[\/source\]!isU', $thePost, $theSources );

		// Cut 'em from the posting
		foreach( $theSources[0] as $sourceID => $sourceBlock )
			$thePost = str_replace( $sourceBlock, "<p>{sourceID:{$sourceID}}</p>", $thePost );

		// Auto-p & texturize the posting
		$thePost = wpautop( wptexturize( $thePost ) );

		// Create pre-tag for SyntaxHighlighter
		$textArea = 
			'<pre name="code" class="%s" cols="%s" rows="%s">%s</pre>';

		// Re-insert source as (formatted) textarea
		foreach( $theSources[2] as $sourceID => $sourceBlock ) {
			$theBrush =
				$theSources[1][$sourceID].$optionString; 
			$thePost = str_replace( 
				"<p>{sourceID:{$sourceID}}</p>", 
				sprintf( $textArea, $theBrush, 60, 10, $sourceBlock ), 
				$thePost 
			);
		}

		return $thePost;
	}
	else
		// No code, no business!
		$IsCodeInPost = 0;
		return wpautop( wptexturize( $thePost ) );
}

// Add Scripts to footer, including css
function syntaxFooter() {
	global $IsCodeInPost;
	if($IsCodeInPost == 1){
		$syntaxPath = get_option('siteurl') .'/wp-content/mu-plugins/SyntaxHighlighter/';
		echo "\n\t<link type=\"text/css\" rel=\"stylesheet\" href=\"{$syntaxPath}SyntaxHighlighter.css\" />\n";
		echo "\n\n<!-- SyntaxHighlighter Start -->"
			."\n\t<script type=\"text/javascript\" src=\"{$syntaxPath}shCore.js\"></script>";  
		?>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shCore.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushCSharp.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushPhp.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushJScript.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushJava.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushVb.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushSql.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushXml.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushDelphi.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushPython.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushRuby.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushCss.js"></script>
		<script class="javascript" src="<?php echo $syntaxPath; ?>shBrushCpp.js"></script>
		<script class="javascript">
		dp.SyntaxHighlighter.ClipboardSwf = '<?php echo $syntaxPath; ?>clipboard.swf';
		dp.SyntaxHighlighter.HighlightAll('code');
		</script>
		<?php
	}
}

// Modify Filters
remove_filter( 'the_content', 'wpautop' );
remove_filter( 'the_content', 'wptexturize' );

// Modify Actions
add_action( 'the_content', 'syntaxPost' );
add_action( 'wp_footer', 'syntaxFooter' );

?>
